//% Basic replication files for Financial Business Cycles
//% copyright: Matteo Iacoviello 2011
//% Needs Dynare3 to run

@#define countrylist =["c1","c2"]

@#define oneprice = 1

var
@#for c in countrylist
@{c}aa   
@{c}ab  
@{c}acbb  
@{c}acbh
@{c}acdb
@{c}acdh
@{c}acke
@{c}ackh
@{c}aclb
@{c}acle
@{c}ad
@{c}bb
@{c}bbshare
@{c}bh
@{c}bhshare
@{c}bh2b
@{c}btot
@{c}cb
@{c}ce
@{c}ch
@{c}d
@{c}erbe
@{c}erde
@{c}erke
@{c}erkh
@{c}erle
@{c}g
@{c}ke
@{c}kh
@{c}lb
@{c}le
@{c}l
@{c}n
@{c}rb
@{c}rbe
@{c}rd
@{c}rde
@{c}rke
@{c}rkh
@{c}rl
@{c}rle
@{c}tax
@{c}w
@{c}y
@{c}gshare
// open economy additional variables
@{c}p
@{c}pc
@{c}pm
@{c}bf
@{c}bfshare
@{c}bshare
@{c}acbf
@{c}xi
@{c}egd
@{c}punishment

@#if oneprice == 0
@{c}yd
@{c}ym
@{c}yc 
@#endif

@{c}un
@{c}uch
@{c}vke
@{c}vkh
@{c}ike
@{c}ikh
@{c}ctot
@{c}itot
@{c}nx

@#endfor
;


varexo 
@#for c in countrylist
@{c}eps_a @{c}eps_b @{c}eps_c @{c}eps_d @{c}eps_g @{c}eps_p
@#endfor
;

parameters
@#for c in countrylist
@{c}BETAH @{c}BETAB @{c}BETAE
@{c}ALPHA @{c}MIU
@{c}M @{c}RHO_AA @{c}RHO_AB @{c}RHO_XI @{c}ASS
@{c}GAMMAB @{c}GAMMAL @{c}GAMMAF @{c}RHOD @{c}RHOE 
@{c}RHOBBAR @{c}RHOBBARL @{c}RHOT @{c}RHOPUNISHMENT
@{c}DELTA
@{c}FIBH @{c}FIDB @{c}FIDH @{c}FIKE @{c}FIKH @{c}FIBB @{c}FILB @{c}FILE
@{c}TTOB @{c}TBAR  @{c}FIBF 
@{c}SHARE_BHSS @{c}SHARE_BBSS @{c}SHARE_BFSS @{c}BBSS @{c}BHSS @{c}BFSS
@{c}YSS @{c}RLSS @{c}LESS @{c}LBSS @{c}RKESS @{c}RKHSS @{c}DSS @{c}KESS @{c}KHSS 
@{c}RBSS @{c}RDSS @{c}LSS @{c}CBSS @{c}CESS @{c}CHSS @{c}RHO_AD 
@{c}SIGMAB @{c}SIGMAH @{c}SIGMAE 
@{c}ILAGRB @{c}ILAGRD @{c}ILAGRL  @{c}IACEXT
@{c}ETAA @{c}ETAB @{c}NSS
@{c}OMEGA @{c}RHO @{c}BBAR @{c}ELABBAR @{c}GD @{c}BBARLOW @{c}GHH @{c}INVAC
@{c}YSS
@#endfor
;




model;



@#for c in countrylist


// Exceptions -- equations with both home and foreign variables
// for c1 make c2 the foreign country
// for c2 make 
@#if c=="c1"  
@# define f = "c2"
@#else
@# define f = "c1"
@#endif

//% Household 1-5
@{c}pc*@{c}ch + @{c}p*@{c}d + @{c}p*@{c}bh  + @{c}pc*@{c}kh 
+ @{c}p*@{c}acbh + @{c}p*@{c}acdh = + @{c}p*@{c}rde*@{c}d(-1)  + 
 + @{c}p*@{c}rbe*@{c}bh(-1) + @{c}p*(@{c}rkh+1-@{c}DELTA)*@{c}kh(-1)
 + @{c}w*@{c}n - @{c}pc*@{c}tax + @{c}ab - @{c}bh(-1)/@{c}btot(-1)*@{c}ad ;
		 
//% Definition of marginal utilities
@{c}uch = (1-@{c}GHH)*(@{c}ch-@{c}xi)^(-@{c}SIGMAH) +
@{c}GHH*((@{c}ch-@{c}xi-@{c}ETAA/(1+@{c}ETAB)*@{c}n^(1+@{c}ETAB))^(-@{c}SIGMAH)) ;

@{c}un = (1-@{c}GHH)*(@{c}ETAA*@{c}n^@{c}ETAB) +  
@{c}GHH*(@{c}uch*@{c}ETAA*@{c}n^@{c}ETAB);

(1+@{c}acdh)*@{c}uch*@{c}p/@{c}pc = @{c}BETAH*@{c}uch(+1)*(@{c}rde(+1)+@{c}IACEXT*@{c}acdh(+1))*@{c}p(1)/@{c}pc(1);

(1+@{c}acbh)*@{c}uch*@{c}p/@{c}pc = @{c}BETAH*@{c}uch(+1)*(@{c}rbe(+1)-@{c}ad(1)/@{c}btot+@{c}IACEXT*@{c}acbh(+1))*@{c}p(1)/@{c}pc(1);

@{c}INVAC*
((@{c}vkh)*@{c}uch - @{c}BETAH*@{c}uch(+1)*(@{c}rkh(+1)+(1-@{c}DELTA)*@{c}IACEXT*@{c}vkh(+1)))
+(1-@{c}INVAC)*
((1+@{c}ackh)*@{c}uch - @{c}BETAH*@{c}uch(+1)*(@{c}rkh(+1)+1-@{c}DELTA+@{c}IACEXT*@{c}ackh(+1)))
=0;

@{c}w*@{c}uch = @{c}un ;


//% Bank 6-11
//% budget constraint

@{c}pc*@{c}cb + @{c}p*@{c}rde*@{c}d(-1) + @{c}p*@{c}l + @{c}p*@{c}bb +@{c}pm*@{c}bf +
     @{c}p*@{c}aclb + @{c}p*@{c}acbb + @{c}p*@{c}acdb + @{c}pm*@{c}acbf = 
     @{c}p*@{c}d + @{c}p*@{c}rle*@{c}l(-1) + @{c}p*@{c}rbe*@{c}bb(-1) + @{c}pm*@{f}rbe*@{c}bf(-1)  
     - @{c}ab - @{c}bb(-1)/@{c}btot(-1)*@{c}ad - @{c}bf(-1)/@{f}btot(-1)*@{f}ad ;


//% borrowing constraint
@{c}p*@{c}d-@{c}RHOD*( @{c}p*@{c}d(-1)-@{c}p*@{c}l(-1)-
@{c}p*(@{c}bb(-1)-@{c}bb(-1)/@{c}btot(-1)*@{c}ad(-1)-@{c}bf(-1)/@{f}btot(-1)*@{f}ad(-1))-@{c}pm*@{c}bf(-1) ) 
-@{c}p*(1-(1-@{c}RHOD)*(1-@{c}GAMMAL))*(@{c}l-(@{c}ab))
-@{c}p*(1-(1-@{c}RHOD)*(1-@{c}GAMMAB))*(@{c}bb)
-@{c}pm*(1-(1-@{c}RHOD)*(1-@{c}GAMMAF))*(@{c}bf) = 0;

// foc wrt d
(1-@{c}acdb-(@{c}lb))*(@{c}cb(1)^@{c}SIGMAB)*@{c}p/@{c}pc =
@{c}BETAB*(@{c}cb^@{c}SIGMAB)*((@{c}rde(+1))-@{c}RHOD*(@{c}lb(+1))-@{c}IACEXT*@{c}acdb(+1))*@{c}p(1)/@{c}pc(1);

// foc wrt l
(1+@{c}aclb-(@{c}RHOD+(1-@{c}RHOD)*@{c}GAMMAL)*(@{c}lb))*(@{c}cb(1)^@{c}SIGMAB)*@{c}p/@{c}pc =
@{c}BETAB*(@{c}cb^@{c}SIGMAB)*((@{c}rle(+1))-@{c}RHOD*(@{c}lb(+1))+@{c}IACEXT*@{c}aclb(+1))*@{c}p(1)/@{c}pc(1);

// foc wrt bb
(1+@{c}acbb-(@{c}RHOD+(1-@{c}RHOD)*@{c}GAMMAB)*(@{c}lb))*(@{c}cb(1)^@{c}SIGMAB)*@{c}p/@{c}pc =
@{c}BETAB*(@{c}cb^@{c}SIGMAB)*((@{c}rbe(+1)-@{c}ad(1)/@{c}btot)-@{c}RHOD*(@{c}lb(+1))+@{c}IACEXT*@{c}acbb(+1))*@{c}p(1)/@{c}pc(1);

// foc wrt bf
(1+@{c}acbf-(@{c}RHOD+(1-@{c}RHOD)*@{c}GAMMAF)*(@{c}lb))*(@{c}cb(1)^@{c}SIGMAB)*@{c}pm/@{c}pc =
@{c}BETAB*(@{c}cb^@{c}SIGMAB)*((@{f}rbe(+1)-@{f}ad(1)/@{f}btot)-@{c}RHOD*(@{c}lb(+1))+@{c}IACEXT*@{c}acbf(+1))*@{c}pm(1)/@{c}pc(1);


//@{c}bf = @{c}BFSS;


//% Entre 12-15

@{c}pc*@{c}ce + @{c}pc*@{c}ke + @{c}p*@{c}rle*@{c}l(-1) + @{c}p*@{c}acle =
@{c}pc*(@{c}rke+1-@{c}DELTA)*@{c}ke(-1) +@{c}p*@{c}l ;

@{c}p*@{c}l = @{c}p*@{c}RHOE*@{c}l(-1) + @{c}pc*(1-@{c}RHOE)*( @{c}M*(@{c}ke)  ) ;

(1-@{c}acle-(@{c}le))/(@{c}ce^@{c}SIGMAE)*@{c}p/@{c}pc =
@{c}BETAE*(@{c}rle(+1)-@{c}IACEXT*@{c}acle(+1)-@{c}RHOE*@{c}le(+1))/(@{c}ce(+1)^@{c}SIGMAE)*@{c}p(1)/@{c}pc(1)  ;

@{c}INVAC*(
@{c}vke*(1-(@{c}le)*(1-@{c}RHOE)*@{c}M)/(@{c}ce^@{c}SIGMAE) -
@{c}BETAE*((@{c}rke(+1))+(1-@{c}DELTA)*@{c}IACEXT*@{c}vke(+1))/(@{c}ce(+1)^@{c}SIGMAE))
+(1-@{c}INVAC)*(
(1+@{c}acke-(@{c}le)*(1-@{c}RHOE)*@{c}M)/(@{c}ce^@{c}SIGMAE) - 
@{c}BETAE*((@{c}rke(+1))+1-@{c}DELTA+@{c}IACEXT*@{c}acke(+1))/(@{c}ce(+1)^@{c}SIGMAE)) = 0;



//% Firm 16-19

log(@{c}y) = (@{c}aa) + @{c}ALPHA*@{c}MIU*log(@{c}ke(-1)) + @{c}ALPHA*(1-@{c}MIU)*log(@{c}kh(-1)) + (1-@{c}ALPHA)*log(@{c}n) ;

@{c}ALPHA*@{c}MIU*(@{c}y) = (@{c}rke)*(@{c}ke(-1)) ;

@{c}ALPHA*(1-@{c}MIU)*(@{c}y) = (@{c}rkh)*(@{c}kh(-1)) ;

(1-@{c}ALPHA)*(@{c}y) = (@{c}w)*(@{c}n) ;


//% bundlers 20-24

//@{c}yc = ((1-@{c}OMEGA)^(@{c}RHO/(1+@{c}RHO))*@{c}yd^(1/(1+@{c}RHO)) + @{c}OMEGA^(@{c}RHO/(1+@{c}RHO))*@{c}ym^(1/(1+@{c}RHO)) )^(1+@{c}RHO);



@#if oneprice == 1
@{c}pc = 1;
@{c}pm = 1;

@#else
@{c}yc = @{c}g + @{c}ch + @{c}cb + @{c}ce + @{c}kh-(1-@{c}DELTA)*@{c}kh(-1)+@{c}ke-(1-@{c}DELTA)*@{c}ke(-1);

@{c}y = @{c}yd + @{f}ym;

@#if c=="c1"  
@{c}ym = @{c}OMEGA*(@{c}pm/@{c}pc)^(-(1+@{c}RHO)/@{c}RHO)*@{c}yc;
@#else
@{c}pm = 1/@{f}pm;
@#endif

@{c}yd = (1-@{c}OMEGA)*(@{c}p/@{c}pc)^(-(1+@{c}RHO)/@{c}RHO)*@{c}yc;

@{c}pc = ((1-@{c}OMEGA)*(@{c}p)^(-1/@{c}RHO)+@{c}OMEGA*@{c}pm^(-1/@{c}RHO))^(-@{c}RHO);
@#endif



//% Govt 25-27

@{c}p*@{c}bb + @{c}p*@{c}bh + @{c}p*@{f}bf = @{c}p*@{c}rbe*( @{c}bb(-1)+@{c}bh(-1)+@{f}bf(-1) )
-@{c}ad + @{c}pc*@{c}g - @{c}pc*@{c}tax  ; 

@{c}egd = -@{c}p(1)*@{c}btot(1) + @{c}rb*( @{c}btot )
-@{c}ad(1) + @{c}pc*@{c}g(1) - @{c}pc*@{c}tax(1);  


//% @{c}g/@{c}y = @{c}GBAR ;

//@{c}pc*@{c}tax = @{c}TBAR*@{c}YSS + @{c}RHOBBARL *(@{c}btot - @{c}BBAR*@{c}YSS) + @{c}RHOBBAR*(@{c}btot-@{c}btot(-1)) ;

@{c}p*@{c}bb + @{c}p*@{c}bh + @{c}p*@{f}bf = 
(1-@{c}RHOBBAR)*((@{c}BBAR*exp(-@{c}ELABBAR*@{c}ad))*(@{c}p*@{c}y))
+ (@{c}RHOBBAR)*(@{c}p*@{c}bb(-1) + @{c}p*@{c}bh(-1) + @{c}p*@{f}bf(-1)) 
-@{c}punishment;

@#if c=="c1"  
@{c}punishment = @{c}RHOPUNISHMENT*@{c}punishment(-1)+@{c}eps_p;
@#else
@{c}punishment = 0;
@#endif


@{c}tax = @{c}RHOT*@{c}tax(-1) +
(1-@{c}RHOT)*@{c}TBAR*@{c}y+@{c}eps_g ;

//%+ @{c}TTOB * (@{c}bh-@{c}ad+@{c}bb+@{f}bf-@{c}bh(-1)-@{c}bb(-1)-@{f}bf(-1)+@{c}ad(-1) )) ;


//% Fix numeraire 28
@{c}p = 1;

//% Shocks 29-31

//% Technology shock
@{c}aa - log(@{c}ASS)= @{c}RHO_AA*(@{c}aa(-1)- log(@{c}ASS)) + @{c}eps_a ; 

//% Default of Entrepreneurs on Banks
@{c}ab = @{c}RHO_AB*(@{c}ab(-1)) + @{c}eps_b; 


//% Default of Govt on HH and Banks
@{c}ad = @{c}RHO_AD*(@{c}ad(-1)) + @{c}eps_d; 

//% Consumption Preference Shock
@{c}xi = @{c}RHO_XI*(@{c}xi(-1)) + @{c}eps_c;

//% adjustment costs FIDH is adj cost of D for HH 33-41
@{c}acbb   = @{c}FIBB*((@{c}bb)-@{c}bb(-1))/(@{c}BBSS) ;
@{c}acbh   = @{c}FIBH*((@{c}bh)-@{c}bh(-1))/(@{c}BHSS) ;
@{c}acbf   = @{c}FIBF*((@{c}bf)-@{c}bf(-1))/(@{c}BFSS) ;
@{c}acdb   = @{c}FIDB*((@{c}d)-(@{c}d(-1)))/@{c}d(-1) ;
@{c}acdh   = @{c}FIDH*((@{c}d)-(@{c}d(-1)))/@{c}d(-1) ;
@{c}acke   = @{c}INVAC*(@{c}FIKE*((@{c}ike)-(@{c}ike(-1)))/@{c}ike(-1))
            +(1-@{c}INVAC)*(@{c}FIKE*((@{c}ke)-(@{c}ke(-1)))/@{c}ke(-1));
@{c}ackh   = @{c}INVAC*(@{c}FIKH*((@{c}ikh)-(@{c}ikh(-1)))/@{c}ikh(-1))
            +(1-@{c}INVAC)*(@{c}FIKH*((@{c}kh)-(@{c}kh(-1)))/@{c}kh(-1));
@{c}aclb = @{c}FILB*((@{c}l)-(@{c}l(-1)))/@{c}l(-1) ;
@{c}acle = @{c}FILE*((@{c}l)-(@{c}l(-1)))/@{c}l(-1) ;

//% 42
@{c}bh2b = @{c}bh/(@{c}bh+@{c}bb+@{f}bf);

//% indices for timing of interest rates 42-44
@{c}rbe = @{c}ILAGRB*@{c}rb(-1) + (1-@{c}ILAGRB)*@{c}rb ;
@{c}rde = @{c}ILAGRD*@{c}rd(-1) + (1-@{c}ILAGRD)*@{c}rd ;
@{c}rle = @{c}ILAGRL*@{c}rl(-1) + (1-@{c}ILAGRL)*@{c}rl ;

//% definition of expected interest rates 46-50
@{c}erbe = @{c}rbe(+1);
@{c}erde = @{c}rde(+1);
@{c}erke = @{c}rke(+1);
@{c}erkh = @{c}rkh(+1);
@{c}erle = @{c}rle(+1);

//% definition of bond shares
@{c}bfshare = @{c}pm*@{c}bf/(@{c}p*@{c}y*4);
@{c}bhshare = @{c}bh/(@{c}y*4);
@{c}bbshare = @{c}bb/(@{c}y*4);
@{c}p*@{c}btot = @{c}p*@{c}bb + @{c}p*@{c}bh + @{c}p*@{f}bf;

//% additional definitions
@{c}gshare = @{c}pc*@{c}g/(@{c}p*@{c}YSS);
@{c}bshare = @{c}btot/@{c}y;

@{c}INVAC*
(((1-@{c}acke)*@{c}vke-1)/(@{c}ce^@{c}SIGMAE) + 
@{c}BETAE*@{c}IACEXT*@{c}acke(+1)/(@{c}ce(+1)^@{c}SIGMAE))
+(1-@{c}INVAC)*
(@{c}vke-1)
=0 ;

@{c}INVAC*
(((1-@{c}ackh)*@{c}vkh-1)*@{c}uch +
@{c}BETAH*@{c}IACEXT*@{c}ackh(+1)*@{c}uch(+1))
+(1-@{c}INVAC)*
(@{c}vkh-1)
=0 ;

@{c}ike   = (@{c}ke)-(1-@{c}DELTA)*(@{c}ke(-1));
@{c}ikh   = (@{c}kh)-(1-@{c}DELTA)*(@{c}kh(-1));

@{c}ctot = @{c}ch+@{c}cb+@{c}ce;
@{c}itot = @{c}ikh+@{c}ike;
@{c}p*@{c}nx = @{c}p*@{c}y -@{c}pc*@{c}ctot - @{c}pc*@{c}itot - @{c}pc*@{c}g;


@#endfor
end;


//% steady ;

shocks;
@#for c in countrylist
var @{c}eps_a; stderr 0.01;
var @{c}eps_b; stderr 0.000001;
var @{c}eps_c; stderr 0.10;
var @{c}eps_d; stderr 0.000001;

@#endfor

end;

//% write_latex_dynamic_model;
//% The static model can also be written with the command.
//% write_latex_static_model 

//%check ;


//%stoch_simul(order=1,print,irf=0,qz_criterium=1.00001) c1y c1rbe c1btot c1tax ;
stoch_simul(order=1,noprint,periods=200,drop=0,irf=0,qz_criterium=1.00001)  ;
