
% close all
clear
setpathdynare4
warning off

% modname below chooses model
% directory. But simple param choices are made from paramfile in current
% directory.


  c1ETAB=3; % 0.5
  c1GHH=1;  % 0
  c1FIKE=5; % 0.5
  c1INVAC=1;
  c1IACEXT=1;
  c1RHOPUNISHMENT=0.50;
  c1RHOBBAR=0.50;
  c1FIBB=0.20;
  c1FIBF=0.20;
  c1FIBH=0.20;
  ACHOL=0;
  c1RHOT=0.5;
  c1GHH=0;
  
  
  save XPARAMS c1ETAB c1GHH c1FIKE c1INVAC c1IACEXT c1RHOPUNISHMENT ...
    c1FIBB c1FIBF c1FIBH c1RHOBBAR  ACHOL c1RHOT c1GHH



%PENALUT=0.4;
PENALUT = 0;
XXX=0;
% PENALUT=100;

modnam = 'm1.mod';
modnamstar = 'm1default.mod';




%% DO NOT EDIT THIS PART

tol0 = 1e-8;

%% Pick innovation for IRFs
irfshock =char('c1eps_a');      % label for innovation for IRFs
scalefactormod = [  -0.05  ];


nperiods = size(scalefactormod,1)+39;          %length of IRFs

errlist = [];                % only needed for stochastic simulations


% solve model
eval(['dynare ',modnam,' noclearall'])
oobase_ = oo_;
Mbase_ = M_;

eval(['dynare ',modnamstar,' noclearall'])
m1_steadystate;
oostar_ = oo_;
Mstar_ = M_;

nvars = Mbase_.endo_nbr;
ys_ = oobase_.dr.ys;

paramfile_m1
def_parm_asym1

[hm1,h,hl1,Jbarmat] = get_deriv(Mbase_,ys_);
cof = [hm1,h,hl1];

[hm1,h,hl1,Jstarbarmat,resid] = get_deriv(Mstar_,ys_);
cofstar = [hm1,h,hl1];
Dstarbarmat = resid;

[decrulea,decruleb]=get_pq(oobase_.dr);
endog_ = M_.endo_names;
exog_ =  M_.exo_names;

nshocks = size(scalefactormod,1);
init = zeros(nvars,1);
zdataconcatenated = zeros(nperiods,nvars);
%%
for ishock = 1:nshocks
    wishlist = endog_;
    % generate IRFs for wishlist. IRFs are save in ZDATA
    zdataunc = mkdata(nperiods+1,decrulea,decruleb,endog_,exog_,wishlist,irfshock,scalefactormod(ishock),init);
    
    % unpack ZDATA
    nwishes = size(wishlist,1);
    for i=1:nwishes
        eval([deblank(wishlist(i,:)),'_unc=zdataunc(:,i);']);
    end
    
    % MODIFY HERE
    %violvec=find(ere_unc+ress<SIGMABAR/GAMMA);
    tol0=10^-4;
    
    c1g = c1GSS+c1g_unc;
    
    un = c1g;
    
    
    violvecbool = 0*c1rbe;
    violvecbool(1) = 1;  % guess that a switch occurs in period 1
    
    defaultindx =1;
    
    % check switch for one period
    
    % analyse violvec and isolate contiguous periods in the other regime.
    regime(1) = violvecbool(1);
    regimeindx = 1;
    regimestart(1) = 1;
    for i=2:nperiods
        if violvecbool(i)~=regime(regimeindx)
            regimeindx=regimeindx+1;
            regime(regimeindx) = violvecbool(i);
            regimestart(regimeindx)=i;
        end
    end
    
    
    if (regime(1) == 1 & length(regimestart)==1)
        error('Increase nperiods');
    end
    
    if (regime(end)==1)
        error('Increase nperiods');
    end
    
    
    
    [zdata]=mkdatap_anticipated(nperiods,decrulea,decruleb,...
        cof,Jbarmat,cofstar,Jstarbarmat,Dstarbarmat,...
        regime,regimestart,violvecbool,...
        endog_,exog_,irfshock,scalefactormod(ishock),init);
    
    for i=1:nwishes
        eval([deblank(wishlist(i,:)),'_difference=zdata(:,i);']);
    end
    
    
    % MODIFY HERE
    
    c1g  = c1GSS+c1g_difference;
    
    
    ud=c1g;
    
    %newviolvecbool = ere_difference+ress<SIGMABAR/GAMMA ;
    %relaxconstraint = ere_difference+ress>SIGMABAR/GAMMA ;
    
    
    if (un(1)>ud(1)-PENALUT*(1:(1+nperiods)).^XXX')
        zdata = zdataunc;
        % TO DO: check that at no future date will there be a shift
        
        
    else  % check no default tomorrow
        clear regime regimestart
        violvecbool(2) = 1;
        regime(1) = violvecbool(1);
        regimeindx = 1;
        regimestart(1) = 1;
        for i=2:nperiods
            if violvecbool(i)~=regime(regimeindx)
                regimeindx=regimeindx+1;
                regime(regimeindx) = violvecbool(i);
                regimestart(regimeindx)=i;
            end
        end
        
        
        if (regime(1) == 1 & length(regimestart)==1)
            error('Increase nperiods');
        end
        
        if (regime(end)==1)
            error('Increase nperiods');
        end
        
        
        
        [zdata2]=mkdatap_anticipated(nperiods,decrulea,decruleb,...
            cof,Jbarmat,cofstar,Jstarbarmat,Dstarbarmat,...
            regime,regimestart,violvecbool,...
            endog_,exog_,irfshock,scalefactormod(ishock),init);
        
        for i=1:nwishes
            eval([deblank(wishlist(i,:)),'_difference=zdata2(:,i);']);
        end
        
        
        % MODIFY HERE
        
        c1g  = c1GSS+c1g_difference;
     
        
        
        ud2 = c1g;
        if (ud2(2)>ud(2)-PENALUT*(1:(1+nperiods)).^XXX')
            display('Warning -- default in second period from shock -- check third period')
        end
        
    end
    clear regime regimestart
    
    
    
    
    
    
    init = zdata(1,:);
    zdataconcatenated(ishock,:)=init;
    init= init';
    
end


%%
zdataconcatenated(ishock+1:end,:)=zdata(2:nperiods-ishock+1,:);



zdata = mkdata(nperiods,decrulea,decruleb,endog_,exog_,wishlist,irfshock,scalefactormod);

load benchmark_sim


for i=1:nwishes
    eval([deblank(wishlist(i,:)),'_benchmark_uncdifference=zdata_benchmark(:,i);']);
    eval([deblank(wishlist(i,:)),'_benchmark_ss=ys_benchmark(i);']);
    eval([deblank(wishlist(i,:)),'_benchmark_difference=zdataconcatenated_benchmark(:,i);']);
    eval([deblank(wishlist(i,:)),'_uncdifference=zdata(:,i);']);
    eval([deblank(wishlist(i,:)),'_ss=oobase_.dr.ys(i);']);
    eval([deblank(wishlist(i,:)),'_difference=zdataconcatenated(:,i);']);
end

zdata_runm1_switch = zdataconcatenated;  % save for use in other plots
zdata_runm1_switch_unc = zdata;
save runm1_switch1_results zdata_runm1_switch zdata_runm1_switch_unc 

%% modify to plot IRFs

titlelist = char('Periphery, Output','Periphery, Capital',...
                 'Periphery, Government Spending (share of SS output)', 'Periphery, Household Consumption',...
                 'Periphery, Public Debt (share of SS annualized output)', 'Periphery, Loan Rate (5-Year)',...
                 'Core, Output ','Core, Hours Worked');
percent = '% change';
ppta = 'PPt change, annualized';
value = 'value';

ylabels = char(percent,percent,...
               percent,percent,...
               ppta,ppta,...
               percent,percent);


figtitle = '';

c1rle5_benchmark_difference = [movingaverage(c1rle_benchmark_difference,20);zeros(20,1)]; 
c1rle5_difference = [movingaverage(c1rle_difference,20);zeros(20,1)]; 

line1=100*[c1y_benchmark_difference/c1y_ss, c1ke_benchmark_difference/c1ke_ss,...
           c1gshare_benchmark_difference ,c1ch_benchmark_difference/c1ch_ss,...
           c1btot_benchmark_difference/c1y_ss/4,c1rle5_benchmark_difference*4,...
           c2y_benchmark_difference/c2YSS, c2n_benchmark_difference/c2n_ss];       


line2=100*[c1y_difference/c1y_ss, c1ke_difference/c1ke_ss,...
           c1gshare_difference ,c1ch_difference/c1ch_ss,...
           c1btot_difference/c1y_ss/4,c1rle5_difference*4,...
           c2y_difference/c2YSS, c2n_difference/c2n_ss];       
    

legendlist = cellstr(char('Benchmark, GHH Preferences','KPR Preferences'));
% violation=find(ere_difference+ress<SIGMABAR/GAMMA);
% line3=NaN*line1;
% line3(violation,:)=line1(violation,:);
% endplot=size(line1,1);


% makechart_location(titlelist,legendlist,'SouthEast',figtitle,ylabels,line1(1:20,:),line2(1:20,:));

c1rle5_benchmark_uncdifference = [movingaverage(c1rle_benchmark_uncdifference,20);zeros(20,1)]; 
c1rle5_uncdifference = [movingaverage(c1rle_uncdifference,20);zeros(20,1)]; 

line1unc=100*[c1y_benchmark_uncdifference/c1y_ss, c1ke_benchmark_uncdifference/c1ke_ss,...
           c1gshare_benchmark_uncdifference ,c1ch_benchmark_uncdifference/c1ch_ss,...
           c1btot_benchmark_uncdifference/c1y_ss/4,c1rle5_benchmark_uncdifference*4,...
           c2y_benchmark_uncdifference/c2YSS, c2ke_benchmark_uncdifference/c2ke_ss];       


line2unc=100*[c1y_uncdifference/c1y_ss, c1ke_uncdifference/c1ke_ss,...
           c1gshare_uncdifference ,c1ch_uncdifference/c1ch_ss,...
           c1btot_uncdifference/c1y_ss/4,c1rle5_uncdifference*4,...
           c2y_uncdifference/c2YSS, c2ke_uncdifference/c2ke_ss];       
    

 makechart_location(titlelist,legendlist,'SouthEast',figtitle,ylabels,line1(1:20,:)-line1unc(1:20,:),line2(1:20,:)-line1unc(1:20,:));



figure
subplot(2,1,1)
plot(c1btot_difference/c1y_ss*25,'k')
hold on; plot(c2bf_difference/c1y_ss*25,'b--')
hold on; plot(c1bh_difference/c1y_ss*25,'r:')
hold on; plot(c1bb_difference/c1y_ss*25,'g-.')
title('Periphery, Sovereign Borrowing (share of annualized output)')
legend('Total G. Borrowing','Foreign Borr.','Borr. from HHs','Borr. from Banks','Location','SouthEast')
ylabel('Percentage Point Change from S.S.')
xlim([1 40])

subplot(2,1,2)
plot(c1nx_difference/c1y_ss*100,'k');
hold on
plot(c1nx_uncdifference/c1y_ss*100,'r--');
title('Periphery, Net Exports (share of output)')
ylabel('Percentage Point Change from S.S.')
xlabel('Quarters')
xlim([1 40])
% subplot(2,2,3)
% 
% plot(c1bf_difference/c1y_ss*25)
% title('C2 borrowing from c1 banks (c1 output share)')
% 
% subplot(2,2,4)
% plot((c1bf_difference-c2bf_difference)/c1y_ss*25)
% title('C1 NFA (c1 output share)')



figure
subplot(2,3,1)
plot(c1rb_difference*400,'k')
hold on
plot(c2rb_difference*400,'k--')
title('Government Borrowing Rate (AR), Default')
legend('Periphery','Core','Location','SouthEast')
xlim([1 length(c2rb_difference)])


subplot(2,3,2)
plot(c1rd_difference*400,'k')
hold on
plot(c2rd_difference*400,'k--')
title('Deposit Rate (AR), Default')
xlim([1 length(c2rb_difference)])

subplot(2,3,3)
plot(c1rl_difference*400,'k')
hold on
plot(c2rl_difference*400,'k--')
title('Loan Rate (AR), Default')
xlim([1 length(c2rb_difference)])


subplot(2,3,4)
plot(c1rb_uncdifference*400,'r')
hold on
plot(c2rb_uncdifference*400,'r--')
title('Government Borrowing Rate (AR), No Default')
legend('Periphery','Core','Location','SouthEast')
xlim([1 length(c2rb_difference)])

subplot(2,3,5)
plot(c1rd_uncdifference*400,'r')
hold on
plot(c2rd_uncdifference*400,'r--')
title('Deposit Rate (AR), No Default')
xlim([1 length(c2rb_difference)])

subplot(2,3,6)
plot(c1rl_uncdifference*400,'r')
hold on
plot(c2rl_uncdifference*400,'r--')
title('Loan Rate (AR), No Default')
xlim([1 length(c2rb_difference)])



%   % Break things down
%   aaa=[ c1y_difference c2y_difference ...
%     c1ch_difference ...
%     c1cb_difference+c1ce_difference ...
%     c2ch_difference ...
%     c2cb_difference+c2ce_difference ...
%     c1itot_difference c2itot_difference ...
%     c1g_difference c2g_difference ...
%     c1nx_difference c2nx_difference ...
%     c1btot_difference c1bb_difference c1bh_difference c2bf_difference ...
%     c2bb_difference c2l_difference ]/c1y_ss ;
%   
%   summ1= mean(aaa(1:4,:));
%   
%   bbb=4*[ c1rbe_difference c2rbe_difference ...
%     c1rde_difference c2rde_difference ...
%     c1rle_difference c2rle_difference ];
%   summ2= mean(bbb(1:4,:));
%   
%   summ3=[ summ1 NaN summ2 ];
%   
%   summ4(index,:)=summ3;
 
